## mingw-w64-python-freeze-core-0.6.0-1.src.tar.zst

=== Makefile ===
# Makefile to automate some tools
SHELL=/bin/bash
PATH := $(shell python -c "import sysconfig; print(sysconfig.get_path('scripts'))"):$(PATH)

PY_PLATFORM := $(shell python -c "import sysconfig; print(sysconfig.get_platform())")
PRE_COMMIT_OPTIONS := --show-diff-on-failure --color=always --all-files --hook-stage=manual --no-progress

COV_TMPDIR := $(shell mktemp -d)

.PHONY: all
all: install

.PHONY: prek
prek: install
	@(prek run $(PRE_COMMIT_OPTIONS) || true) | more
	@prek cache gc -q

.PHONY: clean
clean: uninstall
	@rm -f .coverage* || true
	@rm -rf build dist wheelhouse
	@prek cache clean -q

.PHONY: install
install:
	./ci/install-tools.sh --dev
	if ! [ -f .git/hooks/pre-commit ]; then\
		prek install --install-hooks --overwrite -t pre-commit;\
	fi

.PHONY: uninstall
uninstall:
	@prek uninstall -q
	@rm -f .git/hooks/pre-commit

.PHONY: upgrade
upgrade: install
	prek auto-update
	$(MAKE) prek

.PHONY: wheel
wheel:
	./ci/build-wheel.sh --install

.PHONY: tests
tests: wheel
	./ci/install-tools.sh --tests
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a tests/ $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && pytest -nauto -v || true

.PHONY: cov
cov: wheel
	./ci/install-tools.sh --tests
	@rm -rf build/coverage_html_report
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a tests/ $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && coverage run || true
	coverage combine --keep --quiet -a $(COV_TMPDIR)/
	coverage report
	coverage html --show-contexts

=== requirements.txt ===
filelock>=3.20.3
cabarchive>=0.2.4 ;sys_platform == 'win32'
striprtf>=0.0.26 ;sys_platform == 'win32'

=== tests/requirements.txt ===
coverage==7.13.4
pytest==9.0.2

=== PKGBUILD ===
# Maintainer: Marcelo Duarte @marcelotduarte
# makepkg-mingw -sCLf

_realname=freeze-core
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=0.6.0
pkgrel=1
pkgdesc="Core dependency for cx_Freeze (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/marcelotduarte/freeze-core/"
msys2_repository_url='https://github.com/marcelotduarte/freeze-core'
msys2_references=(
  'purl: pkg:pypi/freeze-core'
)
license=('spdx:MIT')
depends=(
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-cabarchive"
  "${MINGW_PACKAGE_PREFIX}-python-filelock"
  "${MINGW_PACKAGE_PREFIX}-python-striprtf"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-tools"
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-cx-logging"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pip"
  "${MINGW_PACKAGE_PREFIX}-python-coverage"
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
)
options=(!strip)
source=(
  "https://pypi.org/packages/source/${_realname::1}/${_realname/-/_}/${_realname/-/_}-${pkgver}.tar.gz"
)
sha256sums=(
  "46008c27e0e44bd97e283f2fb21df5190c555ff8dd2b008e6205f03f87f8c2c4"
)

prepare() {
  rm -Rf "${srcdir}"/python-${_realname}-${MSYSTEM}
  cp -a "${srcdir}"/${_realname/-/_}-${pkgver} "${srcdir}"/python-${_realname}-${MSYSTEM}
}

build() {
  cd python-${_realname}-${MSYSTEM}
  python -m build --wheel --skip-dependency-check --no-isolation
}

check() {
  cd python-${_realname}-${MSYSTEM}
  pip install ${_realname} -f dist --no-deps --no-index

  mkdir -p "${srcdir}/python-test-core"
  cp pyproject.toml "${srcdir}/python-test-core/"
  cp -a tests "${srcdir}/python-test-core/tests/"

  cd "${srcdir}/python-test-core"
  coverage run
  coverage combine
  coverage report
}

package() {
  cd python-${_realname}-${MSYSTEM}
  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" dist/*.whl
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/LICENSE"
}
